%option noyywrap

DIGIT [0-9]
DIGITMORE [A-F]
DIGITMORE2 [a-f]
HEXDIGIT {DIGIT}|{DIGITMORE}|{DIGITMORE2}

%{
int howmuch(char hexnum)
{ 
  return ( (hexnum)>'9' ) ? (( (hexnum) & 7)+9) : ( (hexnum) & 15 );
}
%}

%%
"+"	printf(" ");
"%"{HEXDIGIT}{HEXDIGIT}	printf( "%c", (howmuch(yytext[1])<<4) + howmuch(yytext[2]) );
%%
